      *_> CNLLSTSPLF SRCFILE(@2/@1) SRCMBR(@3)
      *_> DLTMOD MODULE(@5/@4)
      *_> CRTRPGMOD MODULE(@5/@4) SRCFILE(@2/@1) SRCMBR(@3) +
      *_>   DBGVIEW(@9) OPTIMIZE(@8) OPTION(*EVENTF)
      * ---------------------------------------------------------------
      * Module.: XVIDAT_M01           Project.....:
      * Author.: A. Campin            Date written: 01/02/2007
      * Purpose: Convert iSeries type dates (Integer, Decimal, Character Fields)
      *            into true data type. Service program implements SQL UDF.
      *          Valid date formats:
      *            *CCYMD  - ISO date CCYYMMDD
      *            *CYMD   - One Digit Century. CYYMMDD.
      *            *MDY    - MMDDYY.
      *            *YMD    - YYMMDD.
      *            *DMY    - DDMMYY.
      *            *MDCCYY - MMDDCCYY.
      *            *JUL    - YYJUL - Julian.
      *            *LJUL   - CCYYJUL - Long Julian.
      *            *JDEJUL - CYYJUL - J.D. Edwards Julian.
      *            *CJUL   - CYYJUL - CYYDDD. Same as *JDEJUL.
      *          Anything else returns an error.
      * ---------------------------------------------------------------
      * Called by: SQL Runtime.
      * ---------------------------------------------------------------
      * Revision history:
      *  Project # Pgmr        Date   Desc
      *
      * End Revision History
      * ---------------------------------------------------------------
     h nomain
     h Option(*Srcstmt:*Nodebugio)

      /copy *libl/qsrcf,cb_Std_Con

      /copy *libl/qsrcf,cb_StdType

      /copy *libl/qsrcf,xvidat_pr

     d StripCharacters...
     d                 pr             8p 0
     d   PR_InCharacterString...
     d                               10a   Varying
     d                                     Value
     d   PR_InDateFormat...
     d                               10a   Varying
     d                                     Value
     d   PR_OutSQLState...
     d                                     Like(StdSQLState)
     d   PR_OutDiagnosticMessage...
     d                               70a   Varying

      * Default date format for this system. If your system has a different
      *  default data format, change it here.
     d cDefaultFormat...
     d                 c                   '*CYMD'
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      * IDAT_Packed_Default
      *   This function is receives an iSeries date in an packed format
      *     assuming a default format.
      *      Input      - iSeries Date in Packed Format.
      *                   In Data Null.
      *                   Function Name being called.
      *                   Specific Name.
      *      Output     - Return Date.
      *                   Return Date Null.
      *                   SQL State on Exit.
      *                   Diagnostic Message.
      *      Returns    - None.
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     p IDAT_Packed_Default...
     p                 b                   Export
     d                 pi
     d   InPackedValue...
     d                                8p 0
     d   OutDate...
     d                                     Like(StdDat)
     d   InDataNull...
     d                                     Like(StdIntSml)
     d   OutNull...
     d                                     Like(StdIntSml)
     d   OutSQLState...
     d                                     Like(StdSQLState)
     d   InFunctionName...
     d                              139a   Varying
     d   InSpecificName...
     d                              128a   Varying
     d   OutDiagnosticMessage...
     d                               70a   Varying

     d DefaultFormat...
     d                 s             10a    Varying
     d                                      Inz(cDefaultFormat)
     d FormatNull...
     d                 s                   Like(StdIntSml)
     d                                     Inz(0)

      /Free

       OutSQLState = cSQLStateOk;

       IDAT_Packed(InPackedValue       :
                   DefaultFormat       :
                   OutDate             :
                   InDataNull          :
                   FormatNull          :
                   OutNull             :
                   OutSQLState         :
                   InFunctionName      :
                   InSpecificName      :
                   OutDiagnosticMessage);

       Return;

      /End-Free
     p                 e
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      * IDAT_Character_Default
      *   This function is receives an iSeries date in an character format
      *     assuming a default format.
      *   Note that this format can include editing characters like - or /.
      *     They are just stripped out.
      *      Input      - iSeries Date in Varying Character.
      *                   In Data Null.
      *                   Function Name being called.
      *                   Specific Name.
      *      Output     - Return Date.
      *                   Return Date Null.
      *                   SQL State on Exit.
      *                   Diagnostic Message.
      *      Returns    - None.
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     p IDAT_Character_Default...
     p                 b                   Export
     d                 pi
     d   InCharacterValue...
     d                               10a   Varying
     d   OutDate...
     d                                     Like(StdDat)
     d   InDataNull...
     d                                     Like(StdIntSml)
     d   OutNull...
     d                                     Like(StdIntSml)
     d   OutSQLState...
     d                                     Like(StdSQLState)
     d   InFunctionName...
     d                              139a   Varying
     d   InSpecificName...
     d                              128a   Varying
     d   OutDiagnosticMessage...
     d                               70a   Varying

     d DefaultFormat...
     d                 s             10a   Inz(cDefaultFormat)
     d                                     Varying
     d FormatNull...
     d                 s                   Like(StdIntSml)
     d                                     Inz(0)
     d Packed80...
     d                 s              8p 0
      /Free

       OutSQLState = cSQLStateOk;
       Packed80 = StripCharacters(%Trim(InCharacterValue):
                                  DefaultFormat          :
                                  OutSQLState            :
                                  OutDiagnosticMessage   );

       // For now, let's just return a null date instead of an error.
       If OutSQLState <> cSQLStateOk;
         OutSqlState = cSQLStateOk;
         OutDiagnosticMessage = *Blanks;
         OutNull = -1;
         Return;
       EndIf;

       IDAT_Packed(Packed80            :
                   DefaultFormat       :
                   OutDate             :
                   InDataNull          :
                   FormatNull          :
                   OutNull             :
                   OutSQLState         :
                   InFunctionName      :
                   InSpecificName      :
                   OutDiagnosticMessage);

       Return;

      /End-Free
     p                 e
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      * IDAT_Integer_Default
      *   This function is receives an iSeries date in an integer format
      *     assuming a default format.
      *      Input      - iSeries Date in Integer.
      *                   In Data Null.
      *                   Function Name being called.
      *                   Specific Name.
      *      Output     - Return Date.
      *                   Return Date Null.
      *                   SQL State on Exit.
      *                   Diagnostic Message.
      *      Returns    - None.
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     p IDAT_Integer_Default...
     p                 b                   Export
     d                 pi
     d   InIntegerValue...
     d                                     Like(StdInt)
     d   OutDate...
     d                                     Like(StdDat)
     d   InDataNull...
     d                                     Like(StdIntSml)
     d   OutNull...
     d                                     Like(StdIntSml)
     d   OutSQLState...
     d                                     Like(StdSQLState)
     d   InFunctionName...
     d                              139a   Varying
     d   InSpecificName...
     d                              128a   Varying
     d   OutDiagnosticMessage...
     d                               70a   Varying

     d DefaultFormat...
     d                 s             10a   Inz(cDefaultFormat)
     d                                     Varying
     d FormatNull...
     d                 s                   Like(StdIntSml)
     d                                     Inz(0)
     d Packed80...
     d                 s              8p 0
      /Free

       OutSQLState = cSQLStateOk;
       Packed80 = %Dec(InIntegerValue:8:0);

       IDAT_Packed(Packed80            :
                   DefaultFormat       :
                   OutDate             :
                   InDataNull          :
                   FormatNull          :
                   OutNull             :
                   OutSQLState         :
                   InFunctionName      :
                   InSpecificName      :
                   OutDiagnosticMessage);

       Return;

      /End-Free
     p                 e
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      * IDAT_Date_Default
      *   This function is receives an iSeries date data type and just returns
      *     the date in deault format.
      *      Input      - iSeries Date Data Type.
      *                   In Data Null.
      *                   Function Name being called.
      *                   Specific Name.
      *      Output     - Return Date.
      *                   Return Date Null.
      *                   SQL State on Exit.
      *                   Diagnostic Message.
      *      Returns    - None.
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     p IDAT_Date_Default...
     p                 b                   Export
     d                 pi
     d   InDateValue...
     d                                     Like(StdDat)
     d   OutDate...
     d                                     Like(StdDat)
     d   InDataNull...
     d                                     Like(StdIntSml)
     d   OutNull...
     d                                     Like(StdIntSml)
     d   OutSQLState...
     d                                     Like(StdSQLState)
     d   InFunctionName...
     d                              139a   Varying
     d   InSpecificName...
     d                              128a   Varying
     d   OutDiagnosticMessage...
     d                               70a   Varying
      /Free

       OutDate = InDateValue;
       OutNull = InDataNull;
       OutSQLState = cSQLStateOk;

       Return;

      /End-Free
     p                 e
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      * IDAT_Packed
      *   This function is receives an iSeries date in packed 8,0 format and a date format
      *     This function does almost all the work and is called by all the other functions.
      *     Value is converted to date data type and returned.
      *      Input      - Packed 8,0 date field.
      *                   Date Format
      *                   In Data Null.
      *                   In Format Null.
      *                   Function Name being called.
      *                   Specific Name.
      *      Output     - Return Date.
      *                   Return Date Null.
      *                   SQL State on Exit.
      *                   Diagnostic Message.
      *      Returns    - None.
      *      Output     - None
      *      Returns    - Date in CCYY-MM-DD format
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     p IDAT_Packed...
     p                 b                   Export
     d                 pi
     d   InPackedValue...
     d                                8p 0
     d   InDateFormat...
     d                               10a   Varying
     d   OutDate...
     d                                     Like(StdDat)
     d   InDataNull...
     d                                     Like(StdIntSml)
     d   InFormatNull...
     d                                     Like(StdIntSml)
     d   OutNull...
     d                                     Like(StdIntSml)
     d   OutSQLState...
     d                                     Like(StdSQLState)
     d   InFunctionName...
     d                              139a   Varying
     d   InSpecificName...
     d                              128a   Varying
     d   OutDiagnosticMessage...
     d                               70a   Varying

     d Up              c                   'ABCDEFGHIJKLMNOPQRSTUVWXYZ'
     d Lo              c                   'abcdefghijklmnopqrstuvwxyz'

     d aString...
     d                 s              8a   Varying
     d aString8...
     d                 s              8a
     d aString5...
     d                 s              5a
     d aString6...
     d                 s              6a
     d aString7...
     d                 s              7a
      /Free

       OutSQLState = cSQLStateOk;
       InDateFormat = %Xlate(Lo:Up:InDateFormat);

       Monitor;
         If InPackedValue = 0;
           OutNull = -1;
           Return;
         Else;
           aString = %EditC(InPackedValue:'X');
         EndIf;
       On-Error;
         OutNull = -1;
         Return;
       EndMon;

       Select;
         When InDateFormat = '*CYMD';
           aString7 = %Subst(aString:2:7);
           Test(ED) *CYMD0 aString7;
           If %Error();
             OutNull = -1;
           Else;
             OutDate = %Date(aString7:*CYMD0);
           EndIf;
         When InDateFormat = '*CCYMD';
           aString8 = aString;
           Test(ED) *ISO0 aString8;
           If %Error();
             OutNull = -1;
           Else;
             OutDate = %Date(aString8:*ISO0);
           EndIf;
         When InDateFormat = '*MDY';
           aString6 = %Subst(aString:3:6);
           Test(ED) *MDY0 aString6;
           If %Error();
             OutNull = -1;
           Else;
             OutDate = %Date(aString6:*MDY0);
           EndIf;
         When InDateFormat = '*YMD';
           aString6 = %Subst(aString:3:6);
           Test(ED) *YMD0 aString6;
           If %Error();
             OutNull = -1;
           Else;
             OutDate = %Date(aString6:*YMD0);
           EndIf;
         When InDateFormat = '*DMY';
           aString6 = %Subst(aString:3:6);
           Test(ED) *DMY0 aString6;
           If %Error();
             OutNull = -1;
           Else;
             OutDate = %Date(aString6:*DMY0);
           EndIf;
         When InDateFormat = '*MDCCYY';
           aString8 = aString;
           Test(ED) *USA0 aString8;
           If %Error();
             OutNull = -1;
           Else;
             OutDate = %Date(aString8:*USA0);
           EndIf;
         When InDateFormat = '*JUL';
           aString5 = %Subst(aString:4:5);
           Test(ED) *JUL0 aString5;
           If %Error();
             OutNull = -1;
           Else;
             OutDate = %Date(aString5:*JUL0);
           EndIf;
         When InDateFormat = '*LJUL';
           aString7 = %Subst(aString:2:7);
           Test(ED) *LONGJUL0 aString7;
           If %Error();
             OutNull = -1;
           Else;
             OutDate = %Date(aString7:*LONGJUL0);
           EndIf;
         When InDateFormat = '*CJUL' Or
              InDateFormat = '*JDEJUL';
           // No direct support for CYYJUL so convert Century number to CC.
           Select;
             When %Subst(aString:3:1) = '0';
               aString7 = '19' + %Subst(aString:4:5);
             When %Subst(aString:3:1) = '1';
               aString7 = '20' + %Subst(aString:4:5);
             Other;
               OutNull = -1;
               Return;
           EndSl;
           Test(ED) *LONGJUL0 aString7;
           If %Error();
             OutNull = -1;
           Else;
             OutDate = %Date(aString7:*LONGJUL0);
           EndIf;
         Other;
           OutSQLState = '38501';
           OutDiagnosticMessage = 'Date Format ' +
                                  %Trim(InDateFormat) +
                                  ' invalid!';
           OutNull = -1;
       EndSl;

       Return;

      /End-Free
     p                 e
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      * IDAT_Character
      *   This function is receives an iSeries date in an character format and
      *     a date format.
      *   Note that this format can include editing characters like - or /.
      *     They are just stripped out.
      *      Input      - iSeries Date in Varying Character.
      *                   Date Format
      *                   In Data Null.
      *                   In Format Null.
      *                   Function Name being called.
      *                   Specific Name.
      *      Output     - Return Date.
      *                   Return Date Null.
      *                   SQL State on Exit.
      *                   Diagnostic Message.
      *      Returns    - None.
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     p IDAT_Character...
     p                 b                   Export
     d                 pi
     d   InCharacterValue...
     d                               10a   Varying
     d   InDateFormat...
     d                               10a   Varying
     d   OutDate...
     d                                     Like(StdDat)
     d   InDataNull...
     d                                     Like(StdIntSml)
     d   InFormatNull...
     d                                     Like(StdIntSml)
     d   OutNull...
     d                                     Like(StdIntSml)
     d   OutSQLState...
     d                                     Like(StdSQLState)
     d   InFunctionName...
     d                              139a   Varying
     d   InSpecificName...
     d                              128a   Varying
     d   OutDiagnosticMessage...
     d                               70a   Varying

     d Packed80...
     d                 s              8p 0
      /Free

       OutSQLState = cSQLStateOk;
       Packed80 = StripCharacters(%Trim(InCharacterValue):
                                  InDateFormat           :
                                  OutSqlState            :
                                  OutDiagnosticMessage   );

       // For now, let's just return a null date instead of an error.
       If OutSQLState <> cSQLStateOk;
         OutSqlState = cSQLStateOk;
         OutDiagnosticMessage = *Blanks;
         OutNull = -1;
         Return;
       EndIf;

       IDAT_Packed(Packed80            :
                   InDateFormat        :
                   OutDate             :
                   InDataNull          :
                   InFormatNull        :
                   OutNull             :
                   OutSQLState         :
                   InFunctionName      :
                   InSpecificName      :
                   OutDiagnosticMessage);

       Return;

      /End-Free
     p                 e
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      * IDAT_Integer
      *   This function is receives an iSeries date in an integer format
      *     and a date format.
      *      Input      - iSeries Date in Integer.
      *                   Date Format
      *                   In Data Null.
      *                   In Format Null.
      *                   Function Name being called.
      *                   Specific Name.
      *      Output     - Return Date.
      *                   Return Date Null.
      *                   SQL State on Exit.
      *                   Diagnostic Message.
      *      Returns    - None.
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     p IDAT_Integer...
     p                 b                   Export
     d                 pi
     d   InIntegerValue...
     d                                     Like(StdInt)
     d   InDateFormat...
     d                               10a   Varying
     d   OutDate...
     d                                     Like(StdDat)
     d   InDataNull...
     d                                     Like(StdIntSml)
     d   InFormatNull...
     d                                     Like(StdIntSml)
     d   OutNull...
     d                                     Like(StdIntSml)
     d   OutSQLState...
     d                                     Like(StdSQLState)
     d   InFunctionName...
     d                              139a   Varying
     d   InSpecificName...
     d                              128a   Varying
     d   OutDiagnosticMessage...
     d                               70a   Varying

     d Packed80...
     d                 s              8p 0
      /Free

       OutSQLState = cSQLStateOk;
       Packed80 = %Dec(InIntegerValue:8:0);
       IDAT_Packed(Packed80            :
                   InDateFormat        :
                   OutDate             :
                   InDataNull          :
                   InFormatNull        :
                   OutNull             :
                   OutSQLState         :
                   InFunctionName      :
                   InSpecificName      :
                   OutDiagnosticMessage);

       Return;

      /End-Free
     p                 e
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      * IDAT_Date
      *   This function is receives an iSeries date data type and a date format
      *     In this case, format is ignored and the date is just returned.
      *      Input      - iSeries Date Data Type.
      *                   Date Format
      *                   In Data Null.
      *                   In Format Null.
      *                   Function Name being called.
      *                   Specific Name.
      *      Output     - Return Date.
      *                   Return Date Null.
      *                   SQL State on Exit.
      *                   Diagnostic Message.
      *      Returns    - None.
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     p IDAT_Date...
     p                 b                   Export
     d                 pi
     d   InDateValue...
     d                                     Like(StdDat)
     d   InDateFormat...
     d                               10a   Varying
     d   OutDate...
     d                                     Like(StdDat)
     d   InDataNull...
     d                                     Like(StdIntSml)
     d   InFormatNull...
     d                                     Like(StdIntSml)
     d   OutNull...
     d                                     Like(StdIntSml)
     d   OutSQLState...
     d                                     Like(StdSQLState)
     d   InFunctionName...
     d                              139a   Varying
     d   InSpecificName...
     d                              128a   Varying
     d   OutDiagnosticMessage...
     d                               70a   Varying
      /Free

       OutDate     = InDateValue;
       OutNull     = InDataNull;
       OutSQLState = cSQLStateOk;

      /End-Free
     p                 e
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
      * StripCharacters.
      *   This function removes any characters except number from an incoming
      *     character field but in order to do so it must normalize the data.
      *     For example, "9-5-2007" must be normalized to "09052007" or we
      *     will get garbage.
      *      Input      - iSeries Date in Character Format, blanks trimmed.
      *                   Date Format
      *      Output     - None
      *      Returns    - Value in Decimal(8,0).
      * - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
     p StripCharacters...
     p                 b
     d                 pi             8p 0
     d   InCharacterString...
     d                               10a   Varying
     d                                     Value
     d   InDateFormat...
     d                               10a   Varying
     d                                     Value
     d   OutSQLState...
     d                                     Like(StdSQLState)
     d   OutDiagnosticMessage...
     d                               70a   Varying

     d cNumbers...
     d                 c                   '0123456789'
     d x...
     d                 s                   Like(StdInt)
     d aChar...
     d                 s                   Like(StdChr)
     d Buffer...
     d                 s              8a
     d Count...
     d                 s                   Like(StdInt)
     d Separator...
     d                 s                   Like(StdChr)
     d SepCount...
     d                 s                   Like(StdIntSml)
     d String1...
     d                 s              4a   Varying
     d String2...
     d                 s              4a   Varying
     d String3...
     d                 s              4a   Varying
      /Free

       // If blanks, return a zero.
       If InCharacterString = *Blanks;
         Return 0;
       EndIf;

       // If nothing but numbers return as decimal.
       If %Check(cNumbers:InCharacterString) <= 0;
         Return %Dec(InCharacterString:8:0);
       EndIf;

       // Separators in Julian or CYMD dates make no sense
       //   so return zero.
       If InDateFormat = '*CYMD' Or
          InDateFormat = '*JUL'  Or
          InDateFormat = '*LJUL' Or
          InDateFormat = '*CJUL' Or
          InDateFormat = '*JDEJUL';
         OutSQLState = '38501';
         OutDiagnosticMessage = 'Date Format ' +
                                %Trim(InDateFormat) +
                                ' cannot have separators';
         Return 0;
       EndIf;

       // Get out the string pieces and do some reasonableness
       //  checking. Must have something like xx/xx/xxxx or
       //  xxxx-xx-xx or x/x/xx or xx/x/xxxx. Anything else is
       //  going to be invalid.
       For x = 1 To %Len(InCharacterString);
         aChar = %Subst(InCharacterString:x:1);
         If aChar = *Blank; // Embedded blanks are not allowed.
           OutSQLState = '38501';
           OutDiagnosticMessage = 'Date Format ' +
                                  %Trim(InDateFormat) +
                               ' cannot have embedded blank for separators';
           Return 0;
         EndIf;

         If %Check(cNumbers:aChar) = 0; // Found a number.
           Count += 1;
           %Subst(Buffer:Count:1) = aChar;
           Iter;
         EndIf;

         // Something beside a number found. If we have seen
         //   something before must be same character.
         If Separator <> *Blank;
           If Separator <> aChar;
             OutSQLState = '38501';
             OutDiagnosticMessage = 'Date Format ' +
                                    %Trim(InDateFormat) +
                                    ' separators must have the same';
             Return 0;
           EndIf;
         EndIf;

         // Save the separator character and extract string piece.
         Separator = aChar;
         SepCount += 1;
         Select;
           When SepCount = 1;
             String1 = %Subst(Buffer:1:Count);
           When SepCount = 2;
             String2 = %Subst(Buffer:1:Count);
           Other;
             Return 0;
         EndSl;
         Buffer = *Blanks;
         Count  = 0;
       EndFor;

       // Error check. If nothing in buffer (No third piece) or
       //  two separators not seen, invalid date. Return 0.
       If Count = 0 Or
          SepCount <> 2;
         OutSQLState = '38501';
         OutDiagnosticMessage = 'Date Format ' +
                                %Trim(InDateFormat) +
                                ' has an invalid formatted date';
         Return 0;
       EndIf;

       // Extract last piece.
       String3 = %Subst(Buffer:1:Count);

       // Anything that is 1 byte should be two bytes with a zero
       //   in front.
       If %Len(String1) = 1;
         String1 = '0' + String1;
       EndIf;
       If %Len(String2) = 1;
         String2 = '0' + String2;
       EndIf;
       If %Len(String3) = 1;
         String3 = '0' + String3;
       EndIf;

       // Ok, now we can string back together and return result
       Monitor;
         Return %Dec(String1 + String2 + String3:8:0);
       On-Error;
         OutSQLState = '38501';
         OutDiagnosticMessage = 'Date Format ' +
                                %Trim(InDateFormat) +
                                ' has an invalid formatted date';
         Return 0;
       EndMon;

      /End-Free
     p                 e
